##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (LibMath2-SH)	= PkgName
# sampledir (ksm-libmath2-sh)	= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (sampleconf)	= config file name (no extension)
# sampledm (sampledm)		= the daemon (rc-script, rc-link, systemd.service)
# sample (sample)		= all others
##############################################################################

# Specfile for LibMath2-SH

%define name	ksm-libmath2-sh
%define version	4.0.0
%define release	0.0.0
%define _arch	noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _uxbindir	/usr/bin
%define _uxsbindir	/usr/sbin
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}
%define _libdir		/usr/local/lib/sh

Summary:	Mathematical library for software from Kaesmann-Online
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		System/Libraries
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	samplepkg,samplecapab
Requires:	bc
#Requires:	
#Provides:	sampledm
#Conflicts:	ksm-libmath-sh
#Obsoletes:	mysampledm

%description
This package contains the shell function library libfuncmath2-sh, needed for 
other software from Kaesmann-Online. 

Implemented functions of libfuncmath2-sh (most all of them work with 
fractional numbers):
 X_plus_Y, X_minus_Y, X_mul_Y, X_div_Y, X_rem_Y, X_mod_Y, X_exp_Y, sqrt_X, 
 sine_X, cosine_X, arctan_X, nlog_X, E_exp_X, N_bessel_X,
 X_LT_Y, X_LE_Y, X_GT_Y, X_GE_Y, X_EQ_Y, X_NE_Y, 
 Trim_0NumberI, Trim_NumberI, Trim_NumberF, Insert_Decimalpoint, IsNumber, 
 ToNormInt, NormInt_ToInt, NormInt_ToFloat, Rnd2I, Cross_sum

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/sample.conf
#%config %{_confdir}/sample.conf
#%config %{_scnfdir}/sample
#%{_confdir}/main.conf

#%attr(744,root,root)/%{_rcdir}/sampleserver

#%attr(755,root,root)%{_bindir}/replcnfvar

%{_datadir}/RELEASE
%{_datadir}/VERSION
%attr(755,root,root)%{_datadir}/testmath2

%{_libdir}/libfuncmath2-sh-%{version}

#/usr/share/applications/sample.desktop

#%{_icondir}/16x16/apps/sample.png
#%{_icondir}/22x22/apps/sample.png
#%{_icondir}/32x32/apps/sample.png
#%{_icondir}/48x48/apps/sample.png
#%{_icondir}/64x64/apps/sample.png
#%{_icondir}/128x128/apps/sample.png
#/usr/share/pixmaps/sample.png

#%docdir %{_man1dir}
#%{_man1dir}/replcnfvar.1.gz

#%docdir %{_man8dir}
#%{_man8dir}/sample.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
%{_docdir}/README.de

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

#ngroup='' nuser='' npwd='' ncomm='' nhomedir='' nlogsh='' ngid=0 nuid=0 ret=0

# backup config files
#test -e %{_confdir}/sampleconf.conf && cp %{_confdir}/sampleconf.conf %{_confdir}/sampleconf.conf.rpmsave
#test -e %{_scnfdir}/sampleconf && cp %{_scnfdir}/sampleconf %{_scnfdir}/sampleconf.rpmsave

# disable sample daemon and stop sampledm
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - uninstall samplename
#if [ -d %{_sysddir} ]; then				# systemd
#	if [ -e %{_sysddir}/sampledm.service ]; then
#		systemctl stop sampledm.service
#		systemctl disable sampledm.service
#		rm %{_sysddir}/sampledm.service
#		systemctl daemon-reload
#	fi
#else							# SysV init
#	test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop > /dev/null 2>&1
#	insserv -r sampledm > /dev/null 2>&1
#	rm -f %{_rcdir}/sampledm
#	rm -f %{_sbindir}/rcsampledm
#fi

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname and all config vars from new config file
#cf=%{_confdir}/sampleconf.conf
#cnfvars='MyVar1 MyVar2'

#c='' s='' t='' cnt=0 i=0 ret=0
#rcfile='' updcmd='' u='' usr=''

# enable sample daemon
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
ln -sf %{_libdir}/libfuncmath2-sh-%{version} %{_libdir}/libfuncmath2-sh

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - install samplename
#if [ -d %{_sysddir} ]; then				# systemd
#	cp --preserve=mode %{_datadir}/sampledm.service %{_sysddir}/
#	systemctl daemon-reload
#	systemctl enable sampledm.service
#	echo "sampledm is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start sampledm within yast or manual with:"
#	echo "systemctl start sampledm.service"
#else							# SysV init
#	cp --preserve=mode %{_datadir}/sampledm.rc %{_rcdir}/sampledm
#	ln -sf %{_rcdir}/sampledm %{_sbindir}/rcsampledm
#	insserv sampledm > /dev/null 2>&1
#	echo "sampledm is added to the bootprocess and will auto start at next boot."
#	echo "Now configure $cf"
#	echo "You may start sampledm within yast or manual with rcsampledm start"
#fi

#if [ "$1" == 1 ]; then					# install package
#	echo "Configure $cf"
#	echo "Users must create HOME/.samplerc with update-sample"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		# array var MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#
#	# update all users conf START ----------------------------------------
#	rcfile='.samplerc'
#	updcmd="%{_bindir}/update-sample -q"
#	usr=`/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1`
#	for u in "$usr"; do
#		if [ -e /home/$u/$rcfile ]; then
#			/bin/su $u -c "$updcmd"
#		fi
#	done
#	if [ -e /root/$rcfile ]; then
#		$updcmd
#	fi
#	# update all users conf STOP -----------------------------------------
#
#	echo "If new version then users must update HOME/.samplerc with update-sample"
#fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/sampleconf.conf && cp %{_confdir}/sampleconf.conf %{_confdir}/sampleconf.conf.rpmsave
	#test -e %{_scnfdir}/sampleconf && cp %{_scnfdir}/sampleconf %{_scnfdir}/sampleconf.rpmsave

	# disable sample daemon and stop sampledm
	#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	test -e %{_libdir}/libfuncmath2-sh && rm -f %{_libdir}/libfuncmath2-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/sample.directory \
	#	/usr/share/applications/sample.desktop \
	#	/usr/share/applications/sample-admin.desktop

	# INIT SCRIPT/SYSTEMD UNIT - uninstall samplename
	#if [ -d %{_sysddir} ]; then				# systemd
	#	if [ -e %{_sysddir}/sampledm.service ]; then
	#		systemctl stop sampledm.service
	#		systemctl disable sampledm.service
	#		rm %{_sysddir}/sampledm.service
	#		systemctl daemon-reload
	#	fi
	#else							# SysV init
	#	test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop > /dev/null 2>&1
	#	insserv -r sampledm > /dev/null 2>&1
	#	rm -f %{_rcdir}/sampledm
	#	rm -f %{_sbindir}/rcsampledm
	#fi
#else							# upgrade package
fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/ksm-libmath2-sh
#else							# upgrade package
fi
exit 0

%changelog
* Thu Mar 16 2023 Repomaster <repomaster@kaesmann-online.de> 4.0.0-0.0.0
- The library has been revised.
  The call of many of the functions have been changed.
  Now we do not use Transvervariables - the result goes to STDOUT.
- Because of the incompatibility of the old lib and the new lib
  the library has got a new name -> ksm-libmath2-sh
- Use of the old version is deprecated.

* Mon Feb 20 2023 Repomaster <repomaster@kaesmann-online.de> 3.0.7-0.0.0
- The library has been revised/improved
  (added the function 'Cross_Sum').

* Sat Nov 21 2020 Repomaster <repomaster@kaesmann-online.de> 3.0.6-0.0.0
- The library has been revised/improved
  (added the function 'Rnd2I').
- Following functions have been moved from ksm-lib-sh:
  Trim_0NumberI, Trim_NumberI, Trim_NumberF, Insert_Decimalpoint,
  IsNumber, ToNormInt, NormInt_ToInt, NormInt_ToFloat

* Sat Oct 10 2020 Repomaster <repomaster@kaesmann-online.de> 3.0.5-0.0.0
- The library has been revised/improved.
  Now the compare functions give return results
  according to bash:
  TRUE  = 0
  FALSE = 1

* Wed Oct 07 2020 Repomaster <repomaster@kaesmann-online.de> 3.0.4-0.0.0
- The library has been revised/improved
  (added the variable _DEBUG_).

* Wed Sep 30 2020 Repomaster <repomaster@kaesmann-online.de> 3.0.3-0.0.0
- Following functions are new to the library:
  X_LT_Y, X_LE_Y, X_GT_Y,
  X_GE_Y, X_EQ_Y, X_NE_Y

* Fri Mar 13 2020 Repomaster <repomaster@kaesmann-online.de> 3.0.2-1.1.0
- Fixed error in postinstall scriptlet.

* Tue Oct 02 2018 Repomaster <repomaster@kaesmann-online.de> 3.0.2-1.0.0
- Fixed error: PI = Readonly
- PI has changed to _PI_

* Thu Apr 05 2017 Repomaster <repomaster@kaesmann-online.de> 3.0.2-0.0.0
- Fixed false description of function X_mod_Y

* Fri Jan 20 2017 Repomaster <repomaster@kaesmann-online.de> 3.0.1-0.0.0
- All functions have changed their name:
  FROM		TO
  _X_plus_Y_	X_plus_Y
  _X_minus_Y_	X_minus_Y
  _X_mul_Y_	X_mul_Y
  _X_div_Y_	X_div_Y
  _X_rem_Y_	X_rem_Y
  _X_mod_Y_	X_mod_Y
  _X_exp_Y_	X_exp_Y
  _sqrt_X_	sqrt_X
  _sine_X_	sine_X
  _cosine_X_	cosine_X
  _arctan_X_	arctan_X
  _nlog_X_	nlog_X
  _e_exp_X_	e_exp_X
  _N_bessel_X_	N_bessel_X

* Fri Dec 09 2016 Repomaster <repomaster@kaesmann-online.de> 3.0.0-0.1.0
- All functions have been revised
  (fixed a bug in return the result).

* Tue Dec 06 2016 Repomaster <repomaster@kaesmann-online.de> 3.0.0-0.0.0
- The package has been created from
  splitting the package ksm-lib-sh.
